package unican.taller.dao;

import java.io.Reader;
import java.sql.Date;
import java.sql.SQLException;
import java.util.List;

import org.apache.ibatis.io.Resources;


import com.ibatis.sqlmap.client.SqlMapClient;
import com.ibatis.sqlmap.client.SqlMapClientBuilder;


import unican.taller.dao.CocheDaoImpl;
import unican.taller.model.Coche;

import java.io.IOException;

public class CocheDaoImpl implements CocheDao{

	
    /** Variable para trabajar con el SQLMap*/
    private SqlMapClient sqlMap;
   
   
	public CocheDaoImpl() throws IOException {
		super();
		String resource = "ConfiguracionIbatis.xml";
		Reader reader = Resources.getResourceAsReader(resource);
        sqlMap = SqlMapClientBuilder.buildSqlMapClient(reader);
	}

	@SuppressWarnings("unchecked")
	public List<Coche> getCoches() throws SQLException {
		return (List<Coche>)sqlMap.queryForList("getCoches",null);		
	}

	public Coche getCoche(Integer id) throws SQLException {
		return (Coche)sqlMap.queryForObject("getCoche",id);
	}

	
	public Coche getCocheMatricula(String name) throws SQLException {
		return (Coche)sqlMap.queryForObject("getCocheMatricula",name);
	}


	public void addCoche (Coche car) throws SQLException {
		sqlMap.insert("insertCoche", car);
	}
	
	public void updateCoche (Coche car) throws SQLException {
		sqlMap.update("updateCoche", car);
		
	}
	public void deleteCoche (Coche car) throws SQLException {
		sqlMap.delete("removeCoche", car.getId());
	}
	
}
